// #include <stdio.h>
// #include <vgamouse.h>

static int mouse_detected = 0;
static int x_pos, y_pos, delta_x, delta_y;
static int min_x, min_y, max_x, max_y;

void mouse_handler_end(void) {
}

/* since svgalib only gives us position parameters and descents wants both,
   we have to do some calculations for every mouse-call,
   to get all this info available */
   
void svgalib_mouse_poll (void)
{
   mouse_update();
   delta_x = mouse_getx();
   delta_y = mouse_gety();
   mouse_setposition(0,0);
   
   x_pos += delta_x;
   y_pos += delta_y;
   
   if (x_pos > max_x) x_pos = max_x;
   else if (x_pos < min_x) x_pos = min_x;
   if (y_pos > max_y) y_pos = max_y;
   else if (y_pos < min_y) y_pos = min_y;
}

int mouse_init(int enable_cyberman) {
   int fd;
   
   x_pos = y_pos = delta_x = delta_y = min_x = min_y = max_x = max_y = 0;
   
   fd=mouse_init_return_fd("/dev/mouse", vga_getmousetype(), 150);
   if (fd<0) {
       perror("mouse_init");
       fprintf(stderr,"SVGALib: failed to open mouse device %d\n",fd);
       return 1;
   }
   mouse_detected = 1;
   mouse_setxrange(-500,500);
   mouse_setyrange(-500,500);
   mouse_setposition(0,0);
   return 0;
}

/* we can't do this since svgalib's mouse_close is called mouse_close,
   lett's just hope svgalib doesn't go barf when a not correctly
   opened mouse is closed */
/*
void mouse_close()
{
   if (mouse_detected) mouse_close();
}
*/

int mouse_set_limits(int x1, int y1, int x2, int y2)
{
    min_x=x1;
    min_y=y1;
    max_x=x2;
    max_y=y2;
    return 0;
}

void mouse_get_pos(int *x, int *y)
{
   svgalib_mouse_poll();
   *x = x_pos;
   *y = y_pos;
}

void mouse_get_delta(int *dx, int *dy)
{
  svgalib_mouse_poll();
  *dx = delta_x;
  *dy = delta_y;
}

int mouse_get_btns()
{ 
   mouse_update();
   return mouse_getbutton();
}

void mouse_set_pos(int x, int y)
{
   x_pos=x;
   y_pos=y;
}

void mouse_flush() { }
int mouse_button_down_count(int button) { return 0; }
int mouse_button_state(int button) 
{ 
  int buttons;
  
  mouse_update();
  buttons = mouse_getbutton();
  return ((buttons & (0x01 << button))? 1:0);
}

fix mouse_button_down_time(int button) { return 0; }
void mouse_get_cyberman_pos(int *x, int *y) { }
